/*
 * $Id: iotools.h,v 1.3 2000/05/16 02:35:15 resort Exp $
 *
 * This work is copyright James Hawtin (oolon@ankh.org)
 * 2000/1/25
 *
 * This product contains no warranty, liability or fitness to use. The author
 * accepts no liability for problems caused by direct or indirect use of this
 * work. By using this work you agree to all the conditions of the copyright.
 *
 * The ownership of this work will remain that of the author. However 
 * permission is given to use this work in any way required so long as the
 * above copyright message is left intact.
 *
 * The author reserves the right to use any changes made by him or submitted
 * by others in any future release.
 */

#ifndef __IOTOOLS_H__
#define __IOTOOLS_H__

const int buffer_size(8096);

class read_file
{
 public:
  read_file(int f) : fd(f), pos(0), len(0) {};
  int get_char(char &c);
 private:
  int fd;
  int pos;
  int len;
  char buffer[buffer_size];
};

class write_buff
{
public:
  write_buff(int f) : fd(f), pos(0) {};
  int flush(void);
  int putchar(char c);
private:
  int fd;
  int pos;
  char buffer[buffer_size];
};

class expect
{
public:
  void reset() { count =0; };
  void reset(char *message) { count =0; msg = message; };
  expect(char *message) : msg(message), count(0) {};
  int test(char c);
private:
  char *msg;
  int count;
};

int write_wrap(int, const char *, int);

#endif
