/*
 * Jdata abstract explanding buffers aka Jbuf
 *
 * $Id: jbuf.h,v 1.1 2000/05/19 16:17:41 resort Exp $
 *
 * This work is copyright James Hawtin (oolon@ankh.org)
 * 2000/5/19
 *
 * This product contains no warranty, liability or fitness to use. The author
 * accepts no liability for problems caused by direct or indirect use of this
 * work. By using this work you agree to all the conditions of the copyright.
 *
 * The ownership of this work will remain that of the author. However 
 * permission is given to use this work in any way required so long as the
 * above copyright message is left intact.
 *
 * The author reserves the right to use any changes made by him or submitted
 * by others in any future release.
 */

#include <jdata.h>
#include <jstring.h>

class jbuf
{
  char get(size_t);
  set(size_t, char);
  char *value(void);
  size_t len(void);
  size_t max(void);
  int load(const char *);
  int load(Jstring &tmp) { return load(tmp.value()); };
  int save(const char *, int options=O_CREAT|O_TRUNC, int mode=0644);
  int save(Jstring &tmp, int options=O_CREAT|O_TRUNC, int mode=0644)
    { return save(tmp.value(), options, mode); };
  jbuf();
  ~jbuf();
private:
  Jdata *real;
}
