/*
 * This file has been renamed from jstring_data.h as it generic now.
 * and used with other master object types, which are not all strings!
 *
 * $Id: jdata.h,v 1.6 2000/05/19 16:17:42 resort Exp $
 *
 * This work is copyright James Hawtin (oolon@ankh.org)
 * 2000/1/3
 *
 * This product contains no warranty, liability or fitness to use. The author
 * accepts no liability for problems caused by direct or indirect use of this
 * work. By using this work you agree to all the conditions of the copyright.
 *
 * The ownership of this work will remain that of the author. However 
 * permission is given to use this work in any way required so long as the
 * above copyright message is left intact.
 *
 * The author reserves the right to use any changes made by him or submitted
 * by others in any future release.
 */

#ifndef __J_DATA_H__
#define __J_DATA_H__

#include <sys/types.h>

class Jdata;
class Jstring;
class Jdata_shutdown_helper;

const int jdata_stat_total(13);
const size_t jdata_sizer_minimium(64);

class Jdata_stat
{
 public:
  Jdata_stat();
  size_t sz;
  int total_used;
  int total_free;
  int created;
  int requested;
  int freed;
  int destroyed;
  int relocate;
  int split;
  size_t bytes;
  Jdata *free_chain;
};

class Jdata_stats
{
 public:
  Jdata_stat        stats[jdata_stat_total];
  Jdata_stat       *find_bucket(size_t sz);
  Jdata_stats();
  ~Jdata_stats();
};

enum Jdata_type
{
  JDATA_FREE,
  JDATA_STRING,
  JDATA_BUFFER,
  JDATA_CHAIN
};

class Jdata
{
  friend class Jdata_shutdown_helper;
 public:
  int type;
  unsigned int count;
  size_t size;
  size_t length;
  char *data;
  Jdata *prev;
  Jdata *next;
  ~Jdata();
  void add(void);
  void debugprint(void) const;
  int remove(void);
  static int jstring_data_keep_buffers;
  static int jstring_data_max_free;
  static size_t sizer(const size_t max,
		      const size_t pref=jdata_sizer_minimium);
  static Jdata *create(enum Jdata_type, size_t, int,
		       const char * const, bool, bool);
  static void destroy(Jdata *);
  static Jstring stats(void);
 protected:
  // this will never be used but making it protected stops the compiler from
  // moaning
  Jdata();
 private:
  static Jdata_stats *totals;
  static bool shutdown;
  static void remove_cache(void);
  Jdata(enum Jdata_type, size_t, int, const char * const);
  void jstr_data_safe_cpy(const char *, const int);
  Jdata(const Jdata &);
  Jdata &operator=(const Jdata &);
};

#endif



